<template>
  <section id="h-intro">
    <header-component />

    <b-container class="mt-4 mb-4 px-md-0">
      <h2 class="sr-only">
        Actus
      </h2>
      <b-row>
        <b-col
          id="h-blog"
        >
          <b-row>
            <b-col
              v-for="(article, index) in articles[$t('lang').replace(/^(?!fr$).*$/, 'en')]"
              :key="index"
              class="my-4 px-4"
              md="6"
            >
              <a :href="article.url">
                <img
                  alt=""
                  class="my-4"
                  :src="article.img"
                  style="height: 270px; width: 100%; object-fit: cover"
                />
              </a>
              <p class="small mb-1">
                <i class="fas fa-calendar"></i>
                <time :datetime="article.date">
                  {{ article.date.split('T')[0] }}
                </time>
              </p>
              <div>
                <a :href="article.url">
                  <span
                    v-html="article.title"
                  ></span>
                </a>
                <p
                  class="desc"
                  v-html="article.desc"
                ></p>
                <a :href="article.url">
                  <p class="mt-2 mb-4 text-right">
                    <span class="btn btn-outline-warning">
                      <span v-html="$t('home.intro.blog.read')"></span>
                      <i class="fas fa-chevron-right"></i>
                    </span>
                  </p>
                </a>
              </div>
            </b-col>
          </b-row>
        </b-col>
      </b-row>
    </b-container>
  </section>
</template>

<script>
import HeaderComponent from '../../components/Header.vue';

export default {
  components: {
    HeaderComponent,
  },

  data() {
    return {
      articles: {
        fr: [],
        en: [],
      },
    };
  },
  created() {
    if (/^fr/.test(this.$t('lang'))) {
      this.getArticles('fr');
    } else {
      this.getArticles('en');
    }
  },

  mounted() {
    /* Preload articles (in case the user changes language) */
    if (/^fr/.test(this.$t('lang'))) {
      this.getArticles('en');
    } else {
      this.getArticles('fr');
    }
  },

  methods: {
    getArticles(lg) {
      const url = (lg === 'fr')
        ? 'https://framablog.org/json'
        : 'https://framablog.org/tag/english/json';
      fetch(url)
        .then(res => res.json())
        .then((data) => {
          data.items.forEach((item) => {
            if (this.articles[lg].length < 10) {
              this.articles[lg].push({
                url: item.url,
                title: item.title,
                desc: this.$t(item.content_html.split('<p><span id="more-')[0], '-t'),
                date: item.date_published,
                img: item.image,
              });
            }
          });
        })
        .catch((err) => { console.error(err) }); // eslint-disable-line
    },
  },
};
</script>

<style lang="scss">
#h-intro {
  position: relative;

  &::before {
    background:
      var(--f-f8)
      url('../../../public/img/bg-sky.jpg')
      no-repeat
      center;
    background-size: cover;
    display: block;
    content: '';
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
  }
}

#h-actu {
  > div {
    background:
      var(--f-i9)
      url('../../../public/img/bg-cloud-news.jpg')
      no-repeat
      bottom left;
    background-size: cover;
    border: .75rem solid var(--f-i9);
    min-height: 340px;
    margin-top: 1.5rem;
    margin-bottom: 1.5rem;
    padding-left: 0 !important;
  }

  .h2 {
    background: var(--f-i9);
    color: #fff;
    display: inline;
    font-family: 'Tovari Sans', sans-serif;
    font-size: 2.25rem;
    line-height: 2.5rem;
    margin-top: 1rem;
    @media (min-width: 576px) {
      max-width: 66%;
    }
    padding: 0.5rem .5rem .5rem 1rem;
  }
}

#h-blog,
#h-tube {
  margin: 1rem auto;

  > div {
    background: var(--f-g2);
    border-radius: 1.75rem;
    padding: .5rem 1.5rem;
    position: relative;
    z-index: 1;
    height: 100%;

    div:hover, div:focus {
      background: var(--f-g1);
      border-radius: .75rem;
    }

    a {
      background-image: none;
      color: var(--f-g9);
      font-size: 1.25rem;
      font-weight: bold;

      &:hover, &:focus {
        text-decoration: none;
      }

      p {
        margin-bottom: .5rem;
      }

      p:last-of-type {
        line-height: 1.2;
      }
    }

    .desc {
      -webkit-box-orient: vertical;
      -webkit-line-clamp: 4;
      display: -webkit-box;
      overflow: hidden;
      text-overflow: ellipsis;
      white-space: normal;
    }
  }

  h3 {
    background: var(--f-o6);
    border-radius: .5rem;
    color: #fff;
    font-family: 'Tovari Sans', sans-serif;
    font-size: 1.5rem;
    margin: -1.5rem auto 1.5rem 0;
    padding: .25rem .75rem 0rem;
    text-align: center;
    text-transform: uppercase;
    transform: rotate(-2deg);
    width: fit-content;
  }

  .small {
    color: var(--f-g7) !important;
  }
}

#h-tube img {
  + img {
    position: absolute;
    top: calc(50% - 25%);
    left: calc(50% - 12.5%);
    width: 25%;
  }
}
</style>
